package com.smppw.analysis.application.service.info;

import cn.hutool.core.map.MapUtil;
import com.smppw.analysis.application.dto.info.*;
import com.smppw.analysis.domain.dto.performance.IndicatorParams;
import com.smppw.analysis.domain.manager.performance.Performance;
import com.smppw.analysis.domain.manager.performance.PerformanceConstants;
import com.smppw.analysis.domain.manager.performance.PerformanceFactory;
import com.smppw.analysis.domain.service.BaseInfoService;
import com.smppw.common.pojo.enums.Indicator;
import org.springframework.stereotype.Service;

import java.util.Map;

@Service
public class FundInfoService {
    private final PerformanceFactory factory;
    private final BaseInfoService baseInfoService;

    public FundInfoService(PerformanceFactory factory, BaseInfoService baseInfoService) {
        this.factory = factory;
        this.baseInfoService = baseInfoService;
    }

    public PrivatelyFundHeadInfoVO headInfo(HeadInfoReq params) {
        return new PrivatelyFundHeadInfoVO();
    }

    public CommonInfoVO commonInfo(CommonInfoReq params) {
//        CommonInfoVO res = new CommonInfoVO();
//        IStrategy strategy = StrategyHandleUtils.getStrategy(params.getStrategy());
//        String secId = params.getSecId();
//        Byte raiseType = null;
//        List<Frequency> result = CollectionUtil.newArrayList();
//        String fundType = this.baseInfoService.getFundType(secId);
//        List<IStrategy> originStrategy = CollectionUtil.newArrayList();
//        // 获取频率
//        CmBigDataFundInfoDo fundHeadInfo = fundHeadInfoBaseService.getFundHeadInfo(secId);
//        if (fundHeadInfo == null) {
//            throw new APIException("");
//        }
//        raiseType = fundHeadInfo.getRaiseType();
//        Frequency navFrequency = fundInformationDao.getNavFrequency(secId);
//        result.add(navFrequency);
//        // 将频率转换一道 取最小频率
//        List<Frequency> frequencies = fundInformationDao.toFrequencyList(result);
//        if (raiseType == 2) {
//            frequencies.removeIf(p -> p.getId() == Frequency.Default.getId());
//        }
//        List<ValueLabelVO> frequencyValueLabel = trans2ValueLabel(frequencies);
//        res.setFrequency(frequencyValueLabel);
//        // 净值类型
//        List<ValueLabelVO> navType = Arrays.stream(NavType.values())
//                .filter(p -> !NavType.All.equals(p) && !NavType.UnitAndCumulativeNav.equals(p))
//                .map(p -> new ValueLabelVO(p.name(), p.getDesc())).collect(Collectors.toList());
//        res.setNavType(navType);
//        // 策略曲线
//        RaiseType realRaiseType = RaiseType.getRaiseType(raiseType);
//        handleTimeRange(strategy, res, secId, companyOrManager, realRaiseType);
//        // 获取常用指数
////        List<ValueLabelVO> benchmarkList = userCommonIndexService.getByUser(-1);
////        handleBenchmark(strategy, res, secId, fundType, originStrategy, companyOrManager, benchmarkList);
        return new CommonInfoVO();
    }

    @SuppressWarnings("unchecked")
    public HeadIndicatorVO headIndicator(HeadIndicatorReq req) {
        IndicatorParams params = req.convert();
        Performance<IndicatorParams, Map<String, Object>> instance = this.factory.getInstance(PerformanceConstants.INDICATOR);
        Map<String, Object> dataset = instance.execute(params);
        Map<String, Object> indicatorMap = MapUtil.get(dataset, req.getSecId(), Map.class);
        HeadIndicatorVO vo = new HeadIndicatorVO();
        vo.setAnnualReturn(MapUtil.getStr(indicatorMap, Indicator.AnnualReturn.name()));
        vo.setAnnualStdDev(MapUtil.getStr(indicatorMap, Indicator.AnnualStdDev.name()));
        vo.setMaxDrawdown(MapUtil.getStr(indicatorMap, Indicator.MaxDrawdown.name()));
        vo.setSharpeRatio(MapUtil.getStr(indicatorMap, Indicator.SharpeRatio.name()));
        return vo;
    }
}
